Loading...
Searching...
No Matches
itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage > Class Template Reference

`#include <itkKNNGraphAlphaMutualInformationImageToImageMetric.h>`

## Detailed Description

template<class TFixedImage, class TMovingImage>
class itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >

Computes similarity between two images to be registered.

This metric computes the alpha-Mutual Information (aMI) between two multi-channeled data sets. Said otherwise, given two sets of features, the aMI between them is calculated. Since for higher dimensional aMI it is infeasible to compute high dimensional joint histograms, here we adopt a framework based on the length of certain graphs, see Neemuchwala. Specifically, we use the k-Nearest Neighbour (kNN) graph, using an implementation provided by the Approximate Nearest Neighbour (ANN) software package.

Note that the feature image are given beforehand, and that values are calculated by interpolation on the transformed point. For some features, it would be better (but slower) to first apply the transform on the image and then recalculate the feature.

All the technical details can be found in:
M. Staring, U.A. van der Heide, S. Klein, M.A. Viergever and J.P.W. Pluim, "Registration of Cervical MRI Using Multifeature Mutual Information," IEEE Transactions on Medical Imaging, vol. 28, no. 9, pp. 1412 - 1421, September 2009.

Definition at line 74 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

Inheritance diagram for itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >:
[legend]

## Public Types

using | ANNbdTreeType = ANNbdTree<ListSampleType>
using | ANNBruteForceTreeType = ANNBruteForceTree<ListSampleType>
using | ANNFixedRadiusTreeSearchType = ANNFixedRadiusTreeSearch<ListSampleType>
using | ANNkDTreeType = ANNkDTree<ListSampleType>
using | ANNPriorityTreeSearchType = ANNPriorityTreeSearch<ListSampleType>
using | ANNStandardTreeSearchType = ANNStandardTreeSearch<ListSampleType>
using | BinaryKNNTreePointer = typename BinaryKNNTreeType::Pointer
using | BinaryKNNTreeSearchPointer = typename BinaryKNNTreeSearchType::Pointer
using | BinaryKNNTreeSearchType = BinaryTreeSearchBase<ListSampleType>
using | BinaryKNNTreeType = BinaryTreeBase<ListSampleType>
using | ConstPointer = SmartPointer<const Self>
using | DistanceArrayType = typename BinaryKNNTreeSearchType::DistanceArrayType
using | FixedImageInterpolatorVectorType
using | FixedImageMaskPointer
using | FixedImageMaskType
using | FixedImageMaskVectorType
using | FixedImageRegionVectorType
using | FixedImageVectorType
using | IndexArrayType = typename BinaryKNNTreeSearchType::IndexArrayType
using | InterpolatorVectorType
using | ListSamplePointer = typename ListSampleType::Pointer
using | ListSampleType = typename Statistics::ListSampleCArray<MeasurementVectorType, double>
using | MeasurementVectorType = Array<double>
using | MeasurementVectorValueType = typename MeasurementVectorType::ValueType
using | MovingImageMaskPointer
using | MovingImageMaskType
using | MovingImageMaskVectorType
using | MovingImageVectorType
using | Pointer = SmartPointer<Self>
using | Self = KNNGraphAlphaMutualInformationImageToImageMetric
using | Superclass = MultiInputImageToImageMetricBase<TFixedImage, TMovingImage>
using | TransformJacobianValueType = typename TransformJacobianType::ValueType
Public Types inherited from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >
using | ConstPointer = SmartPointer<const Self>
using | FixedImageInterpolatorPointer = typename FixedImageInterpolatorType::Pointer
using | FixedImageInterpolatorType = InterpolateImageFunction<FixedImageType, CoordinateRepresentationType>
using | FixedImageInterpolatorVectorType = std::vector<FixedImageInterpolatorPointer>
using | FixedImageMaskConstPointer
using | FixedImageMaskPointer
using | FixedImageMaskType
using | FixedImageMaskVectorType = std::vector<FixedImageMaskConstPointer>
using | FixedImagePointer
using | FixedImageRegionVectorType = std::vector<FixedImageRegionType>
using | FixedImageVectorType = std::vector<FixedImageConstPointer>
using | InterpolatorVectorType = std::vector<InterpolatorPointer>
using | MovingImageMaskConstPointer
using | MovingImageMaskPointer
using | MovingImageMaskType
using | MovingImageMaskVectorType = std::vector<MovingImageMaskConstPointer>
using | MovingImagePointer
using | MovingImageVectorType = std::vector<MovingImageConstPointer>
using | Pointer = SmartPointer<Self>
using | Self = MultiInputImageToImageMetricBase
using | Superclass = AdvancedImageToImageMetric<TFixedImage, TMovingImage>
Public Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
using | AdvancedTransformType = AdvancedTransform<ScalarType, FixedImageDimension, MovingImageDimension>
using | BSplineOrder1TransformPointer = typename BSplineOrder1TransformType::Pointer
using | BSplineOrder1TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 1>
using | BSplineOrder2TransformPointer = typename BSplineOrder2TransformType::Pointer
using | BSplineOrder2TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 2>
using | BSplineOrder3TransformPointer = typename BSplineOrder3TransformType::Pointer
using | BSplineOrder3TransformType = AdvancedBSplineDeformableTransform<ScalarType, FixedImageDimension, 3>
using | CombinationTransformType = AdvancedCombinationTransform<ScalarType, FixedImageDimension>
using | ConstPointer = SmartPointer<const Self>
using | DerivativeValueType = typename DerivativeType::ValueType
using | FixedImageLimiterOutputType = typename FixedImageLimiterType::OutputType
using | FixedImageLimiterPointer = typename FixedImageLimiterType::Pointer
using | FixedImageLimiterType = LimiterFunctionBase<RealType, FixedImageDimension>
using | FixedImageMaskConstPointer = SmartPointer<const FixedImageMaskType>
using | FixedImageMaskPointer = SmartPointer<FixedImageMaskType>
using | FixedImageMaskType = ImageMaskSpatialObject<Self::FixedImageDimension>
using | FixedImagePixelType = typename FixedImageType::PixelType
using | FixedImagePointer = typename FixedImageType::Pointer
using | ImageSampleContainerPointer = typename ImageSamplerType::OutputVectorContainerPointer
using | ImageSampleContainerType = typename ImageSamplerType::OutputVectorContainerType
using | ImageSamplerPointer = typename ImageSamplerType::Pointer
using | ImageSamplerType = ImageSamplerBase<FixedImageType>
using | MovingImageDerivativeScalesType = FixedArray<double, Self::MovingImageDimension>
using | MovingImageLimiterOutputType = typename MovingImageLimiterType::OutputType
using | MovingImageLimiterPointer = typename MovingImageLimiterType::Pointer
using | MovingImageLimiterType = LimiterFunctionBase<RealType, MovingImageDimension>
using | MovingImageMaskConstPointer = SmartPointer<const MovingImageMaskType>
using | MovingImageMaskPointer = SmartPointer<MovingImageMaskType>
using | MovingImageMaskType = ImageMaskSpatialObject<Self::MovingImageDimension>
using | MovingImagePointer = typename MovingImageType::Pointer
using | MovingImageRegionType = typename MovingImageType::RegionType
using | NumberOfParametersType = typename AdvancedTransformType::NumberOfParametersType
using | Pointer = SmartPointer<Self>
using | ScalarType = typename TransformType::ScalarType
using | Self = AdvancedImageToImageMetric
using | Superclass = ImageToImageMetric<TFixedImage, TMovingImage>
using | ThreadInfoType = MultiThreaderBase::WorkUnitInfo

## Public Member Functions

virtual const double & | GetAlpha ()
virtual const double & | GetAvoidDivisionBy ()
virtual const char * | GetClassName () const
void | GetDerivative (const TransformParametersType &parameters, DerivativeType &Derivative) const override
MeasureType | GetValue (const TransformParametersType &parameters) const override
void | GetValueAndDerivative (const TransformParametersType &parameters, MeasureType &Value, DerivativeType &Derivative) const override
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (KNNGraphAlphaMutualInformationImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, FixedImageType::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, MovingImageType::ImageDimension)
virtual void | SetAlpha (double _arg)
void | SetANNbdTree (unsigned int bucketSize, std::string splittingRule, std::string shrinkingRule)
void | SetANNbdTree (unsigned int bucketSize, std::string splittingRuleFixed, std::string splittingRuleMoving, std::string splittingRuleJoint, std::string shrinkingRuleFixed, std::string shrinkingRuleMoving, std::string shrinkingRuleJoint)
void | SetANNBruteForceTree ()
void | SetANNFixedRadiusTreeSearch (unsigned int kNearestNeighbors, double errorBound, double squaredRadius)
void | SetANNkDTree (unsigned int bucketSize, std::string splittingRule)
void | SetANNkDTree (unsigned int bucketSize, std::string splittingRuleFixed, std::string splittingRuleMoving, std::string splittingRuleJoint)
void | SetANNPriorityTreeSearch (unsigned int kNearestNeighbors, double errorBound)
void | SetANNStandardTreeSearch (unsigned int kNearestNeighbors, double errorBound)
virtual void | SetAvoidDivisionBy (double _arg)
Public Member Functions inherited from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >
const FixedImageType * | GetFixedImage () const override
virtual const FixedImageType * | GetFixedImage (unsigned int pos) const
virtual FixedImageInterpolatorType * | GetFixedImageInterpolator () const
virtual FixedImageInterpolatorType * | GetFixedImageInterpolator (unsigned int pos) const
const FixedImageMaskType * | GetFixedImageMask () const override
virtual const FixedImageMaskType * | GetFixedImageMask (unsigned int pos) const
const FixedImageRegionType & | GetFixedImageRegion () const override
virtual const FixedImageRegionType & | GetFixedImageRegion (unsigned int pos) const
const InterpolatorType * | GetInterpolator () const override
InterpolatorType * | GetInterpolator () override
virtual InterpolatorType * | GetInterpolator (unsigned int pos) const
virtual bool | GetInterpolatorsAreBSpline () const
const MovingImageType * | GetMovingImage () const override
virtual const MovingImageType * | GetMovingImage (unsigned int pos) const
const MovingImageMaskType * | GetMovingImageMask () const override
virtual const MovingImageMaskType * | GetMovingImageMask (unsigned int pos) const
virtual unsigned int | GetNumberOfFixedImageInterpolators () const
virtual unsigned int | GetNumberOfFixedImageMasks () const
virtual unsigned int | GetNumberOfFixedImageRegions () const
virtual unsigned int | GetNumberOfFixedImages () const
virtual unsigned int | GetNumberOfInterpolators () const
virtual unsigned int | GetNumberOfMovingImageMasks () const
virtual unsigned int | GetNumberOfMovingImages () const
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (MultiInputImageToImageMetricBase)
| itkSetNumberOfMacro (FixedImage)
| itkSetNumberOfMacro (FixedImageInterpolator)
| itkSetNumberOfMacro (FixedImageMask)
| itkSetNumberOfMacro (FixedImageRegion)
| itkSetNumberOfMacro (Interpolator)
| itkSetNumberOfMacro (MovingImage)
| itkSetNumberOfMacro (MovingImageMask)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, TMovingImage::ImageDimension)
void | SetFixedImage (const FixedImageType *_arg) override
virtual void | SetFixedImage (const FixedImageType *_arg, unsigned int pos)
virtual void | SetFixedImageInterpolator (FixedImageInterpolatorType *_arg)
virtual void | SetFixedImageInterpolator (FixedImageInterpolatorType *_arg, unsigned int pos)
void | SetFixedImageMask (const FixedImageMaskType *_arg) override
virtual void | SetFixedImageMask (const FixedImageMaskType *_arg, unsigned int pos)
void | SetFixedImageRegion (const FixedImageRegionType _arg) override
virtual void | SetFixedImageRegion (const FixedImageRegionType _arg, unsigned int pos)
void | SetInterpolator (InterpolatorType *_arg) override
virtual void | SetInterpolator (InterpolatorType *_arg, unsigned int pos)
void | SetMovingImage (const MovingImageType *_arg) override
virtual void | SetMovingImage (const MovingImageType *_arg, unsigned int pos)
void | SetMovingImageMask (const MovingImageMaskType *_arg) override
virtual void | SetMovingImageMask (const MovingImageMaskType *_arg, unsigned int pos)
Public Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
virtual void | BeforeThreadedGetValueAndDerivative (const TransformParametersType &parameters) const
virtual const FixedImageLimiterType * | GetFixedImageLimiter ()
const FixedImageMaskType * | GetFixedImageMask () const override
virtual double | GetFixedLimitRangeRatio () const
ImageSamplerType * | GetImageSampler () const
virtual const MovingImageDerivativeScalesType & | GetMovingImageDerivativeScales ()
virtual const MovingImageLimiterType * | GetMovingImageLimiter ()
const MovingImageMaskType * | GetMovingImageMask () const override
virtual double | GetMovingLimitRangeRatio () const
virtual double | GetRequiredRatioOfValidSamples () const
virtual bool | GetScaleGradientWithRespectToMovingImageOrientation () const
const AdvancedTransformType * | GetTransform () const override
AdvancedTransformType * | GetTransform () override
virtual bool | GetUseFixedImageLimiter () const
virtual bool | GetUseImageSampler () const
virtual const bool & | GetUseMetricSingleThreaded ()
virtual bool | GetUseMovingImageDerivativeScales () const
virtual bool | GetUseMovingImageLimiter () const
virtual const bool & | GetUseMultiThread ()
void | Initialize () override
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedImageToImageMetric)
| itkStaticConstMacro (FixedImageDimension, unsigned int, TFixedImage::ImageDimension)
| itkStaticConstMacro (MovingImageDimension, unsigned int, TMovingImage::ImageDimension)
virtual void | SetFixedImageLimiter (FixedImageLimiterType *_arg)
virtual void | SetFixedLimitRangeRatio (double _arg)
virtual void | SetImageSampler (ImageSamplerType *_arg)
virtual void | SetMovingImageDerivativeScales (MovingImageDerivativeScalesType _arg)
virtual void | SetMovingImageLimiter (MovingImageLimiterType *_arg)
virtual void | SetMovingLimitRangeRatio (double _arg)
virtual void | SetRequiredRatioOfValidSamples (double _arg)
virtual void | SetScaleGradientWithRespectToMovingImageOrientation (bool _arg)
virtual void | SetTransform (AdvancedTransformType *arg)
virtual void | SetUseMetricSingleThreaded (bool _arg)
virtual void | SetUseMovingImageDerivativeScales (bool _arg)
virtual void | SetUseMultiThread (bool _arg)
virtual void | UseMetricSingleThreadedOff ()
virtual void | UseMetricSingleThreadedOn ()
virtual void | UseMultiThreadOff ()
virtual void | UseMultiThreadOn ()

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

| KNNGraphAlphaMutualInformationImageToImageMetric ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~KNNGraphAlphaMutualInformationImageToImageMetric () override=default
Protected Member Functions inherited from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >
virtual void | CheckForBSplineInterpolators ()
bool | EvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient) const override
void | InitializeImageSampler () override
bool | IsInsideMovingMask (const MovingImagePointType &mappedPoint) const override
| MultiInputImageToImageMetricBase ()=default
| ~MultiInputImageToImageMetricBase () override=default
Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
| AdvancedImageToImageMetric ()
virtual void | AfterThreadedGetValue (MeasureType &) const
virtual void | AfterThreadedGetValueAndDerivative (MeasureType &, DerivativeType &) const
void | CheckForAdvancedTransform ()
void | CheckForBSplineInterpolator ()
void | CheckForBSplineTransform () const
void | CheckNumberOfSamples (unsigned long wanted, unsigned long found) const
bool | EvaluateTransformJacobian (const FixedImagePointType &fixedImagePoint, TransformJacobianType &jacobian, NonZeroJacobianIndicesType &nzji) const
virtual void | EvaluateTransformJacobianInnerProduct (const TransformJacobianType &jacobian, const MovingImageDerivativeType &movingImageDerivative, DerivativeType &imageJacobian) const
bool | FastEvaluateMovingImageValueAndDerivative (const MovingImagePointType &mappedPoint, RealType &movingImageValue, MovingImageDerivativeType *gradient, const ThreadIdType threadId) const
void | InitializeLimiters ()
virtual void | InitializeThreadingParameters () const
| itkAlignedTypedef (ITK_CACHE_LINE_ALIGNMENT, PaddedGetValueAndDerivativePerThreadStruct, AlignedGetValueAndDerivativePerThreadStruct)
| itkPadStruct (ITK_CACHE_LINE_ALIGNMENT, GetValueAndDerivativePerThreadStruct, PaddedGetValueAndDerivativePerThreadStruct)
void | LaunchGetValueAndDerivativeThreaderCallback () const
void | LaunchGetValueThreaderCallback () const
void | PrintSelf (std::ostream &os, Indent indent) const override
void | SetFixedImageMask (const typename Superclass::FixedImageMaskType *) final
void | SetFixedImageMask (typename Superclass::FixedImageMaskType *) final
void | SetMovingImageMask (const typename Superclass::MovingImageMaskType *) final
void | SetMovingImageMask (typename Superclass::MovingImageMaskType *) final
virtual void | SetUseFixedImageLimiter (bool _arg)
virtual void | SetUseImageSampler (bool _arg)
virtual void | SetUseMovingImageLimiter (bool _arg)
virtual void | ThreadedGetValue (ThreadIdType) const
virtual void | ThreadedGetValueAndDerivative (ThreadIdType) const
MovingImagePointType | TransformPoint (const FixedImagePointType &fixedImagePoint) const
| ~AdvancedImageToImageMetric () override=default

## Protected Attributes

double | m_Alpha { 0.99 }
double | m_AvoidDivisionBy { 1e-10 }
BinaryKNNTreePointer | m_BinaryKNNTreeFixed { nullptr }
BinaryKNNTreePointer | m_BinaryKNNTreeJoint { nullptr }
BinaryKNNTreePointer | m_BinaryKNNTreeMoving { nullptr }
BinaryKNNTreeSearchPointer | m_BinaryKNNTreeSearcherFixed { nullptr }
BinaryKNNTreeSearchPointer | m_BinaryKNNTreeSearcherJoint { nullptr }
BinaryKNNTreeSearchPointer | m_BinaryKNNTreeSearcherMoving { nullptr }
Protected Attributes inherited from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >
BSplineInterpolatorVectorType | m_BSplineInterpolatorVector {}
FixedImageInterpolatorVectorType | m_FixedImageInterpolatorVector {}
FixedImageMaskVectorType | m_FixedImageMaskVector {}
FixedImageRegionVectorType | m_FixedImageRegionVector {}
FixedImageVectorType | m_FixedImageVector {}
bool | m_InterpolatorsAreBSpline { false }
InterpolatorVectorType | m_InterpolatorVector {}
MovingImageMaskVectorType | m_MovingImageMaskVector {}
MovingImageVectorType | m_MovingImageVector {}
Protected Attributes inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
AdvancedTransformType::Pointer | m_AdvancedTransform { nullptr }
FixedImageLimiterOutputType | m_FixedImageMaxLimit { 1 }
FixedImageLimiterOutputType | m_FixedImageMinLimit { 0 }
FixedImagePixelType | m_FixedImageTrueMax { 1 }
FixedImagePixelType | m_FixedImageTrueMin { 0 }
double | m_FixedLimitRangeRatio { 0.01 }
std::unique_ptr< AlignedGetValueAndDerivativePerThreadStruct[]> | m_GetValueAndDerivativePerThreadVariables
ThreadIdType | m_GetValueAndDerivativePerThreadVariablesSize { 0 }
ImageSamplerPointer | m_ImageSampler { nullptr }
MovingImageLimiterOutputType | m_MovingImageMaxLimit { 1 }
MovingImageLimiterOutputType | m_MovingImageMinLimit { 0 }
MovingImagePixelType | m_MovingImageTrueMax { 1 }
MovingImagePixelType | m_MovingImageTrueMin { 0 }
double | m_MovingLimitRangeRatio { 0.01 }
MultiThreaderParameterType | m_ThreaderMetricParameters {}
bool | m_TransformIsBSpline { false }
bool | m_UseMetricSingleThreaded { true }
bool | m_UseMultiThread { false }

## Private Types

using | MovingImageContinuousIndexType
using | MovingImageDerivativeType
using | MovingImagePointType
using | SpatialDerivativeContainerType = std::vector<SpatialDerivativeType>
using | SpatialDerivativeType = vnl_matrix<double>
using | TransformJacobianContainerType = std::vector<TransformJacobianType>
using | TransformJacobianIndicesContainerType = std::vector<NonZeroJacobianIndicesType>

## Private Member Functions

void | ComputeListSampleValuesAndDerivativePlusJacobian (const ListSamplePointer &listSampleFixed, const ListSamplePointer &listSampleMoving, const ListSamplePointer &listSampleJoint, const bool doDerivative, TransformJacobianContainerType &jacobians, TransformJacobianIndicesContainerType &jacobiansIndices, SpatialDerivativeContainerType &spatialDerivatives) const
virtual void | EvaluateMovingFeatureImageDerivatives (const MovingImagePointType &mappedPoint, SpatialDerivativeType &featureGradients) const

virtual void

UpdateDerivativeOfGammas (const SpatialDerivativeType &D1sparse, const SpatialDerivativeType &D2sparse_M, const SpatialDerivativeType &D2sparse_J, const NonZeroJacobianIndicesType &D1indices, const NonZeroJacobianIndicesType &D2indices_M, const NonZeroJacobianIndicesType &D2indices_J, const MeasurementVectorType &diff_M, const MeasurementVectorType &diff_J, const MeasureType &distance_M, const MeasureType &distance_J, DerivativeType &dGamma_M, DerivativeType &dGamma_J) const

## Additional Inherited Members

Protected Types inherited from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >
using | BSplineInterpolatorPointer = typename BSplineInterpolatorType::Pointer
using | BSplineInterpolatorType
using | BSplineInterpolatorVectorType = std::vector<BSplineInterpolatorPointer>
using | MovingImageContinuousIndexType
using | MovingImageDerivativeType
using | MovingImageIndexType
using | MovingImagePointType
Protected Types inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
using | BSplineInterpolatorFloatPointer = typename BSplineInterpolatorFloatType::Pointer
using | BSplineInterpolatorFloatType
using | BSplineInterpolatorPointer = typename BSplineInterpolatorType::Pointer
using | BSplineInterpolatorType
using | FixedImageIndexType = typename FixedImageType::IndexType
using | FixedImageIndexValueType = typename FixedImageIndexType::IndexValueType
using | FixedImagePointType = typename TransformType::InputPointType
using | LinearInterpolatorPointer = typename LinearInterpolatorType::Pointer
using | LinearInterpolatorType = AdvancedLinearInterpolateImageFunction<MovingImageType, CoordinateRepresentationType>
using | MovingImageContinuousIndexType = typename InterpolatorType::ContinuousIndexType
using | MovingImageDerivativeType = typename BSplineInterpolatorType::CovariantVectorType
using | MovingImageIndexType = typename MovingImageType::IndexType
using | MovingImagePointType = typename TransformType::OutputPointType
using | NonZeroJacobianIndicesType = typename AdvancedTransformType::NonZeroJacobianIndicesType
using | ReducedBSplineInterpolatorPointer = typename ReducedBSplineInterpolatorType::Pointer
using | ReducedBSplineInterpolatorType
Static Protected Member Functions inherited from itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | AccumulateDerivativesThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueAndDerivativeThreaderCallback (void *arg)
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | GetValueThreaderCallback (void *arg)

## Member Typedef Documentation

## ANNbdTreeType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNbdTreeType = ANNbdTree<ListSampleType>

Definition at line 154 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ANNBruteForceTreeType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNBruteForceTreeType = ANNBruteForceTree<ListSampleType>

Definition at line 155 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ANNFixedRadiusTreeSearchType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNFixedRadiusTreeSearchType = ANNFixedRadiusTreeSearch<ListSampleType>

Definition at line 161 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ANNkDTreeType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNkDTreeType = ANNkDTree<ListSampleType>

Definition at line 153 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ANNPriorityTreeSearchType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNPriorityTreeSearchType = ANNPriorityTreeSearch<ListSampleType>

Definition at line 162 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ANNStandardTreeSearchType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ANNStandardTreeSearchType = ANNStandardTreeSearch<ListSampleType>

Definition at line 160 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## BinaryKNNTreePointer

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::BinaryKNNTreePointer = typename BinaryKNNTreeType::Pointer

Definition at line 152 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## BinaryKNNTreeSearchPointer

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::BinaryKNNTreeSearchPointer = typename BinaryKNNTreeSearchType::Pointer

Definition at line 159 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## BinaryKNNTreeSearchType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::BinaryKNNTreeSearchType = BinaryTreeSearchBase<ListSampleType>

Typedefs for tree searchers.

Definition at line 158 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## BinaryKNNTreeType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::BinaryKNNTreeType = BinaryTreeBase<ListSampleType>

Typedefs for trees.

Definition at line 151 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ConstPointer

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ConstPointer = SmartPointer<const Self>

Definition at line 84 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## DistanceArrayType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::DistanceArrayType = typename BinaryKNNTreeSearchType::DistanceArrayType

Definition at line 165 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## FixedImageInterpolatorVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::FixedImageInterpolatorVectorType

Definition at line 110 of file itkMultiInputImageToImageMetricBase.h.

## FixedImageMaskPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageMaskPointer

Definition at line 91 of file itkAdvancedImageToImageMetric.h.

## FixedImageMaskType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::FixedImageMaskType

Definition at line 90 of file itkAdvancedImageToImageMetric.h.

## FixedImageMaskVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::FixedImageMaskVectorType

Definition at line 105 of file itkMultiInputImageToImageMetricBase.h.

## FixedImageRegionVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::FixedImageRegionVectorType

Definition at line 106 of file itkMultiInputImageToImageMetricBase.h.

## FixedImageVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::FixedImageVectorType

Typedef's for storing multiple inputs.

Definition at line 104 of file itkMultiInputImageToImageMetricBase.h.

## IndexArrayType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::IndexArrayType = typename BinaryKNNTreeSearchType::IndexArrayType

Definition at line 164 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## InterpolatorVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::InterpolatorVectorType

Definition at line 109 of file itkMultiInputImageToImageMetricBase.h.

## ListSamplePointer

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ListSamplePointer = typename ListSampleType::Pointer

Definition at line 148 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## ListSampleType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ListSampleType = typename Statistics::ListSampleCArray<MeasurementVectorType, double>

Definition at line 147 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## MeasurementVectorType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::MeasurementVectorType = Array<double>

Typedefs for the samples.

Definition at line 145 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## MeasurementVectorValueType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::MeasurementVectorValueType = typename MeasurementVectorType::ValueType

Definition at line 146 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## MovingImageContinuousIndexType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageContinuousIndexType

private

Definition at line 367 of file itkAdvancedImageToImageMetric.h.

## MovingImageDerivativeType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageDerivativeType

private

Definition at line 366 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskPointer

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageMaskPointer

Definition at line 94 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImageMaskType

Definition at line 93 of file itkAdvancedImageToImageMetric.h.

## MovingImageMaskVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::MovingImageMaskVectorType

Definition at line 108 of file itkMultiInputImageToImageMetricBase.h.

## MovingImagePointType

template<class TFixedImage, class TMovingImage>

using itk::AdvancedImageToImageMetric< TFixedImage, TMovingImage >::MovingImagePointType

private

Definition at line 364 of file itkAdvancedImageToImageMetric.h.

## MovingImageVectorType

template<class TFixedImage, class TMovingImage>

using itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >::MovingImageVectorType

Definition at line 107 of file itkMultiInputImageToImageMetricBase.h.

## Pointer

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::Pointer = SmartPointer<Self>

Definition at line 83 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## Self

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::Self = KNNGraphAlphaMutualInformationImageToImageMetric

Standard itk.

Definition at line 81 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## SpatialDerivativeContainerType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SpatialDerivativeContainerType = std::vector<SpatialDerivativeType>

private

Definition at line 288 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## SpatialDerivativeType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SpatialDerivativeType = vnl_matrix<double>

private

Definition at line 287 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## Superclass

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::Superclass = MultiInputImageToImageMetricBase<TFixedImage, TMovingImage>

Definition at line 82 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## TransformJacobianContainerType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::TransformJacobianContainerType = std::vector<TransformJacobianType>

private

Definition at line 284 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## TransformJacobianIndicesContainerType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::TransformJacobianIndicesContainerType = std::vector<NonZeroJacobianIndicesType>

private

Definition at line 286 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## TransformJacobianValueType

template<class TFixedImage, class TMovingImage>

using itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::TransformJacobianValueType = typename TransformJacobianType::ValueType

Definition at line 168 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## Constructor & Destructor Documentation

## KNNGraphAlphaMutualInformationImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::KNNGraphAlphaMutualInformationImageToImageMetric | ( |  | ) |

protected

Constructor.

## ~KNNGraphAlphaMutualInformationImageToImageMetric()

template<class TFixedImage, class TMovingImage>

itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::~KNNGraphAlphaMutualInformationImageToImageMetric | ( |  | ) |

override protected default

Destructor.

## Member Function Documentation

## ComputeListSampleValuesAndDerivativePlusJacobian()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ComputeListSampleValuesAndDerivativePlusJacobian | ( | const ListSamplePointer & | listSampleFixed,
|  | const ListSamplePointer & | listSampleMoving,
|  | const ListSamplePointer & | listSampleJoint,
|  | const bool | doDerivative,
|  | TransformJacobianContainerType & | jacobians,
|  | TransformJacobianIndicesContainerType & | jacobiansIndices,
|  | SpatialDerivativeContainerType & | spatialDerivatives ) const

private

This function takes the fixed image samples from the ImageSampler and puts them in the listSampleFixed, together with the fixed feature image samples. Also the corresponding moving image values and moving feature values are computed and put into listSampleMoving. The concatenation is put into listSampleJoint. If desired, i.e. if doDerivative is true, then also things needed to compute the derivative of the cost function to the transform parameters are computed:

- The sparse Jacobian of the transformation (dT/dmu).
- The spatial derivatives of the moving (feature) images (dm/dx).

## EvaluateMovingFeatureImageDerivatives()

template<class TFixedImage, class TMovingImage>

virtual void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::EvaluateMovingFeatureImageDerivatives | ( | const MovingImagePointType & | mappedPoint,
|  | SpatialDerivativeType & | featureGradients ) const

private virtual

This function calculates the spatial derivative of the featureNr feature image at the point mappedPoint.

Todo
  move this to base class.

## GetAlpha()

template<class TFixedImage, class TMovingImage>

virtual const double & itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetAlpha | ( |  | ) |

virtual

Get alpha from alpha - mutual information.

## GetAvoidDivisionBy()

template<class TFixedImage, class TMovingImage>

virtual const double & itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetAvoidDivisionBy | ( |  | ) |

virtual

Avoid division by a small number.

## GetClassName()

template<class TFixedImage, class TMovingImage>

virtual const char * itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::MultiInputImageToImageMetricBase< TFixedImage, TMovingImage >.

Reimplemented in elastix::KNNGraphAlphaMutualInformationMetric< TElastix >.

## GetDerivative()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetDerivative | ( | const TransformParametersType & | parameters,
|  | DerivativeType & | Derivative ) const

override

Get the derivatives of the match measure.

## GetValue()

template<class TFixedImage, class TMovingImage>

MeasureType itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetValue | ( | const TransformParametersType & | parameters | ) | const

override

Get the value for single valued optimizers.

## GetValueAndDerivative()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::GetValueAndDerivative | ( | const TransformParametersType & | parameters,
|  | MeasureType & | Value,
|  | DerivativeType & | Derivative ) const

override

Get value and derivatives for multiple valued optimizers.

## Initialize()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::Initialize | ( |  | ) |

override

*** Standard metric stuff: *** Initialize the metric.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TFixedImage, class TMovingImage>

itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage > |  | ) |

## itkStaticConstMacro() [1/2]

template<class TFixedImage, class TMovingImage>

itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | FixedImageDimension | ,
|  | unsigned int | ,
|  | FixedImageType::ImageDimension | )

The fixed image dimension.

## itkStaticConstMacro() [2/2]

template<class TFixedImage, class TMovingImage>

itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::itkStaticConstMacro | ( | MovingImageDimension | ,
|  | unsigned int | ,
|  | MovingImageType::ImageDimension | )

## New()

template<class TFixedImage, class TMovingImage>

Pointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## SetAlpha()

template<class TFixedImage, class TMovingImage>

virtual void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetAlpha | ( | double | _arg | ) |

virtual

Set alpha from alpha - mutual information.

## SetANNbdTree() [1/2]

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNbdTree | ( | unsigned int | bucketSize,
|  | std::string | splittingRule,
|  | std::string | shrinkingRule )

Set ANNbdTree.

## SetANNbdTree() [2/2]

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNbdTree | ( | unsigned int | bucketSize,
|  | std::string | splittingRuleFixed,
|  | std::string | splittingRuleMoving,
|  | std::string | splittingRuleJoint,
|  | std::string | shrinkingRuleFixed,
|  | std::string | shrinkingRuleMoving,
|  | std::string | shrinkingRuleJoint )

Set ANNbdTree.

## SetANNBruteForceTree()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNBruteForceTree | ( |  | ) |

Set ANNBruteForceTree.

## SetANNFixedRadiusTreeSearch()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNFixedRadiusTreeSearch | ( | unsigned int | kNearestNeighbors,
|  | double | errorBound,
|  | double | squaredRadius )

Set ANNFixedRadiusTreeSearch.

## SetANNkDTree() [1/2]

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNkDTree | ( | unsigned int | bucketSize,
|  | std::string | splittingRule )

*** Set trees: *** Currently kd, bd, and brute force trees are supported. Set ANNkDTree.

## SetANNkDTree() [2/2]

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNkDTree | ( | unsigned int | bucketSize,
|  | std::string | splittingRuleFixed,
|  | std::string | splittingRuleMoving,
|  | std::string | splittingRuleJoint )

Set ANNkDTree.

## SetANNPriorityTreeSearch()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNPriorityTreeSearch | ( | unsigned int | kNearestNeighbors,
|  | double | errorBound )

Set ANNPriorityTreeSearch.

## SetANNStandardTreeSearch()

template<class TFixedImage, class TMovingImage>

void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetANNStandardTreeSearch | ( | unsigned int | kNearestNeighbors,
|  | double | errorBound )

*** Set tree searchers: *** Currently standard, fixed radius, and priority tree searchers are supported. Set ANNStandardTreeSearch.

## SetAvoidDivisionBy()

template<class TFixedImage, class TMovingImage>

virtual void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::SetAvoidDivisionBy | ( | double | _arg | ) |

virtual

Avoid division by a small number.

## UpdateDerivativeOfGammas()

template<class TFixedImage, class TMovingImage>

virtual void itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::UpdateDerivativeOfGammas | ( | const SpatialDerivativeType & | D1sparse,
|  | const SpatialDerivativeType & | D2sparse_M,
|  | const SpatialDerivativeType & | D2sparse_J,
|  | const NonZeroJacobianIndicesType & | D1indices,
|  | const NonZeroJacobianIndicesType & | D2indices_M,
|  | const NonZeroJacobianIndicesType & | D2indices_J,
|  | const MeasurementVectorType & | diff_M,
|  | const MeasurementVectorType & | diff_J,
|  | const MeasureType & | distance_M,
|  | const MeasureType & | distance_J,
|  | DerivativeType & | dGamma_M,
|  | DerivativeType & | dGamma_J ) const

private virtual

This function essentially computes D1 - D2, but also takes care of going from a sparse matrix (hence the indices) to a full sized matrix.

## Field Documentation

## m_Alpha

template<class TFixedImage, class TMovingImage>

double itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_Alpha { 0.99 }

protected

Definition at line 275 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_AvoidDivisionBy

template<class TFixedImage, class TMovingImage>

double itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_AvoidDivisionBy { 1e-10 }

protected

Definition at line 276 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeFixed

template<class TFixedImage, class TMovingImage>

BinaryKNNTreePointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeFixed { nullptr }

protected

Member variables.

Definition at line 267 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeJoint

template<class TFixedImage, class TMovingImage>

BinaryKNNTreePointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeJoint { nullptr }

protected

Definition at line 269 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeMoving

template<class TFixedImage, class TMovingImage>

BinaryKNNTreePointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeMoving { nullptr }

protected

Definition at line 268 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeSearcherFixed

template<class TFixedImage, class TMovingImage>

BinaryKNNTreeSearchPointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeSearcherFixed { nullptr }

protected

Definition at line 271 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeSearcherJoint

template<class TFixedImage, class TMovingImage>

BinaryKNNTreeSearchPointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeSearcherJoint { nullptr }

protected

Definition at line 273 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

## m_BinaryKNNTreeSearcherMoving

template<class TFixedImage, class TMovingImage>

BinaryKNNTreeSearchPointer itk::KNNGraphAlphaMutualInformationImageToImageMetric< TFixedImage, TMovingImage >::m_BinaryKNNTreeSearcherMoving { nullptr }

protected

Definition at line 272 of file itkKNNGraphAlphaMutualInformationImageToImageMetric.h.

Generated on 1768596610 for elastix by 1.15.0 |